/*
 This utility performs backsubstitution on a linear system.
 It is to be used in conjunction with ludcmp.c It is taken from:

  Press, William H., et. al., Numerical Recipes in C 2nd Ed., Cambridge University
        Press, New York, 1992.

  page 47.  I have made a few modifications.



	a 	 coefficient matrix
	b    	 rhs vector 
	indx 	 record of the pivoting 

		Updated 5/9/97
*/

#include <stddef.h>
#include <stdio.h>
#include <stdlib.h>
#include <math.h>

int lubksb(double *a, int n, int *indx, double *b)
{
	int i,ii=0,ip,j;
	double sum;

	for (i=1;i<=n; ++i)
	{
		ip=*(indx+(i-1));
		sum=*(b+ip);
		*(b+ip)=*(b+(i-1));
		if (ii)
		{
		   for (j=ii;j<=(i-1); ++j)
		   {
			sum -= *(a+n*(i-1)+(j-1))*(*(b+(j-1)));
		   }
		}
		else if (sum)
		{
			ii=i;
		}
		*(b+(i-1))=sum;
	}
	for (i=n-1;i >=0;--i)
	{
		sum=*(b+i);
		for (j=i+1;j<=n-1;++j)
		{
			sum -= *(a+n*i+j)*(*(b+j));
		}
		*(b+i)=sum/(*(a+n*i+i));
	}
	return 1;
}
