/*
    This program draws the drag down menus.  It works with a finite
    difference mesh.
  
   			Last Update 3/3/08

    SLFCFD source file
    Version:  1.1
    Copyright (C) 2005, 2006, 2007, 2008  San Le 

    The source code contained in this file is released under the
    terms of the GNU Library General Public License.
 
 */

#if WINDOWS
#include <windows.h>
#endif

#include <stdio.h>
#include <stdlib.h>
#include "../compressible/cfdstruct.h"
#include "fdstrcgr.h"
#include "../common_gr/control.h"

#include <GL/gl.h>
#include <GL/glu.h>
#include <GL/glut.h>

extern int nmat, numnp, numel, dof;
extern double *coord;
extern double *U;
extern int *connecter;
extern BOUND bc;
extern double *velocity;
extern GR_NODE *node;
extern XYZF *velocity_vec, *velocity_vec0;
extern I_GR_NODE *node_color;

extern int reget_VelocityList_flag;
extern int input_flag, post_flag, color_choice,
    choice, matl_choice, node_choice, ele_choice;
extern int input_color_flag;
extern int Solid_flag, Perspective_flag, Render_flag,
    AppliedDisp_flag, VelocityVec_flag,
    Material_flag, Node_flag, Element_flag, Axes_flag;
extern int Before_flag, After_flag,
    Both_flag, Time_flag;
extern double amplify_factor, amplify_step, amplify_step0;

extern GLuint VelocityList0, VelocityList;

extern GR_NODE node_div[boxnumber+1];

void velocity_vectors(int , BOUND , double *, XYZF *);

int cfd_set(BOUND , XYZF *, GR_NODE *, I_GR_NODE *, GR_NODE *);

void fdReGetparameter( void);

void cfd_MenuSelect(int value)
{
	int check;

	switch (value) {
	case 1:
	    color_choice = 31;
	    input_color_flag = 0;
	    VelocityVec_flag = 0;
	    AppliedDisp_flag = 0;
	    Element_flag = 0;
	    Material_flag = 0;
	    Node_flag = 1;

	    printf("\n What is the desired node number?\n");
	    scanf("%d", &node_choice);
	    if ( node_choice > numnp - 1 )
	    {
		node_choice = 0;
	    }
	    break;
	case 2:
	    color_choice = 32;
	    input_color_flag = 0;
	    VelocityVec_flag = 0;
	    AppliedDisp_flag = 0;
	    Element_flag = 1;
	    Material_flag = 0;
	    Node_flag = 0;

	    printf("\n What is the desired element number?\n");
	    scanf("%d", &ele_choice);
	    if ( ele_choice > numel - 1 )
	    {
		ele_choice = 0;
	    }
	    Solid_flag = 1;
	    break;
	case 3:
	    color_choice = 30;
	    input_color_flag = 0;
	    VelocityVec_flag = 0;
	    AppliedDisp_flag = 0;
	    Element_flag = 0;
	    Material_flag = 1;
	    Node_flag = 0;

	    printf("\n What is the desired material number?\n");
	    scanf("%d", &matl_choice);
	    if ( matl_choice > nmat - 1 )
	    {
		matl_choice = 0;
	    }
	    Solid_flag = 1;
	    break;
	case 4:
	    fdReGetparameter();
	    check = cfd_set( bc, velocity_vec0, node, node_color, node_div);
	    if(!check) printf( " Problems with cfd_set \n");
#if 0

/* Probably won't work because the Display List applies to the mesh window. */

	    if(reget_VelocityList_flag)
	    {
		if(input_flag)
		{
/* create display list for velocity grapics vectors on input mesh*/
			glDeleteLists(VelocityList0,1);
			VelocityList0 = glGenLists(1);
			velocity_vectors(VelocityList0, bc, coord, velocity_vec0);
		}
		if(post_flag)
		{
/* create display list for velocity grapics vectors on post mesh*/
			glDeleteLists(VelocityList,1);
			VelocityList = glGenLists(1);
			velocity_vectors(VelocityList, bc, coord, velocity_vec);
		}
	    }
#endif
	    break;
	case 5:
	    exit(0);
	    break;
	}

	glutPostRedisplay();

}

void cfd_Menu(void)
{
	glutCreateMenu(cfd_MenuSelect);
	glutAddMenuEntry("Jump node", 1);
	glutAddMenuEntry("Jump ele", 2);
	glutAddMenuEntry("Jump Matl", 3);
	glutAddMenuEntry("Re-Param", 4);
	glutAddMenuEntry("Quit", 5);
	glutAttachMenu(GLUT_RIGHT_BUTTON);
}
