/*
    This program rereads in the parameters of "fdview.dat"
    for the finite difference mesh.
  
                     Last Update 3/20/08

    SLFCFD source file
    Version:  1.1
    Copyright (C) 2006, 2007, 2008  San Le 

    The source code contained in this file is released under the
    terms of the GNU Library General Public License.
 
 */
#include <assert.h>
#include <stddef.h>
#include <stdio.h>
#include <stdarg.h>
#include <stdlib.h>
#include <string.h>
#include <math.h>
#include "../compressible/cfdconst.h"
#include "../compressible/cfdstruct.h"
#include "fdstrcgr.h"
#include "../common_gr/control.h"

#include <GL/gl.h>

#define init_far0      -2.0

extern int nmat, numnp, numel, dof, nx, ny, nz;
extern double time_current, time_current_input, time_current_post;
extern int nstep, cstep, cstep_input, cstep_post;
extern double step_sizex, step_sizey, step_sizez;
extern double left, right, top, bottom, near, far, fscale, coord_rescale;
extern int nxyz_max, nx_inc, ny_inc, nz_inc,
	nxyz_max0, nx_inc0, ny_inc0, nz_inc0, reget_VelocityList_flag;
extern int control_height, control_width, mesh_height, mesh_width;
extern double ortho_left, ortho_right, ortho_top, ortho_bottom;
extern double left_right, up_down, in_out, left_right0, up_down0, in_out0;
extern double AxisMax_x, AxisMax_y, AxisMax_z,
	AxisMin_x, AxisMin_y, AxisMin_z,
	IAxisMin_x, IAxisMin_y, IAxisMin_z;
extern double AxisLength_x, AxisLength_y, AxisLength_z,
	AxisLength_max;
extern double AxisPoint_step;
extern double amplify_step0;

extern double init_right, init_left, init_top,
	init_bottom, init_near, init_far, true_far;
extern GR_NODE del_node, max_node, min_node;
extern GLfloat line_width, point_size,
	line_width0, point_size0;

void fdReGetparameter( void)
{
	int i, j, check;
	int dum, dum1;
	IJK_GR_NODE node_max, node_min;
	char char_dum[20], char_dum2[5], buf[ BUFSIZ ];
	double fdum;
	FILE *fddata;

/*   fddata contains all the parameters and extreme values 
*/
	fddata = fopen( "fdview.dat","r" );

/* Read data from the file "fdview.dat" */

	fscanf( fddata,"\n");
	fgets( buf, BUFSIZ, fddata );
	fgets( buf, BUFSIZ, fddata );
	fgets( buf, BUFSIZ, fddata );
	fscanf( fddata,"%20s    %d %d %d  %d  %d %d %d  %d  %lf %lf\n", char_dum,
		&node_min.dns.i, &node_min.dns.j, &node_min.dns.k, &dum,
		&node_max.dns.i, &node_max.dns.j, &node_max.dns.k, &dum1,
		&min_node.dns, &max_node.dns);
	fscanf( fddata,"%20s    %d %d %d  %d  %d %d %d  %d  %lf %lf\n", char_dum,
		&node_min.temp.i, &node_min.temp.j, &node_min.temp.k, &dum,
		&node_max.temp.i, &node_max.temp.j, &node_max.temp.k, &dum1,
		&min_node.temp, &max_node.temp);
	fscanf( fddata,"%20s    %d %d %d  %d  %d %d %d  %d  %lf %lf\n", char_dum,
		&node_min.prs.i, &node_min.prs.j, &node_min.prs.k, &dum,
		&node_max.prs.i, &node_max.prs.j, &node_max.prs.k, &dum1,
		&min_node.prs, &max_node.prs);
	fscanf( fddata,"%20s %5s   %d %d %d  %d  %d %d %d  %d  %lf %lf\n", char_dum, char_dum2,
		&node_min.vx.i, &node_min.vx.j, &node_min.vx.k, &dum,
		&node_max.vx.i, &node_max.vx.j, &node_max.vx.k, &dum1,
		&min_node.vx, &max_node.vx);
	fscanf( fddata,"%20s %5s   %d %d %d  %d  %d %d %d  %d  %lf %lf\n", char_dum, char_dum2,
		&node_min.vy.i, &node_min.vy.j, &node_min.vy.k, &dum,
		&node_max.vy.i, &node_max.vy.j, &node_max.vy.k, &dum1,
		&min_node.vy, &max_node.vy);
	fscanf( fddata,"%20s %5s   %d %d %d  %d  %d %d %d  %d  %lf %lf\n", char_dum, char_dum2,
		&node_min.vz.i, &node_min.vz.j, &node_min.vz.k, &dum,
		&node_max.vz.i, &node_max.vz.j, &node_max.vz.k, &dum1,
		&min_node.vz, &max_node.vz);
	fscanf( fddata,"%20s    %d %d %d  %d  %d %d %d  %d  %lf %lf\n", char_dum,
		&node_min.enthal.i, &node_min.enthal.j, &node_min.enthal.k, &dum,
		&node_max.enthal.i, &node_max.enthal.j, &node_max.enthal.k, &dum1,
		&min_node.enthal, &max_node.enthal);
	fscanf( fddata,"%20s    %d %d %d  %d  %d %d %d  %d  %lf %lf\n", char_dum,
		&node_min.ene.i, &node_min.ene.j, &node_min.ene.k, &dum,
		&node_max.ene.i, &node_max.ene.j, &node_max.ene.k, &dum1,
		&min_node.ene, &max_node.ene);
	fscanf( fddata,"%20s %10s   %d %d %d  %d  %d %d %d  %d  %lf %lf\n", char_dum, char_dum2,
		&node_min.mach.i, &node_min.mach.j, &node_min.mach.k, &dum,
		&node_max.mach.i, &node_max.mach.j, &node_max.mach.k, &dum1,
		&min_node.mach, &max_node.mach);
	fscanf( fddata,"%20s %10s   %d %d %d  %d  %d %d %d  %d  %lf %lf\n", char_dum, char_dum2,
		&node_min.vmag.i, &node_min.vmag.j, &node_min.vmag.k, &dum,
		&node_max.vmag.i, &node_max.vmag.j, &node_max.vmag.k, &dum1,
		&min_node.vmag, &max_node.vmag);
	fscanf( fddata,"\n");
	fgets( buf, BUFSIZ, fddata );
	fscanf( fddata,"%lf %lf %lf %lf %lf %lf\n", &ortho_right, &ortho_left,
		&ortho_top, &ortho_bottom, &near, &fdum);
	fgets( buf, BUFSIZ, fddata );
	fscanf( fddata,"%d %d\n", &mesh_width, &mesh_height);
	fgets( buf, BUFSIZ, fddata );
	fscanf( fddata,"%lf %lf %lf\n", &step_sizex, &step_sizey, &step_sizez);
	fgets( buf, BUFSIZ, fddata );
	fscanf( fddata,"%lf\n", &amplify_step0);
	fgets( buf, BUFSIZ, fddata );
	fscanf( fddata,"%d %lf\n", &cstep, &time_current);
	fgets( buf, BUFSIZ, fddata );
	fscanf( fddata,"%d %d %d\n", &nx_inc, &ny_inc, &nz_inc);
	fgets( buf, BUFSIZ, fddata );
	fscanf( fddata,"%f %f\n", &line_width, &point_size);

	fclose( fddata );

	printf(  "                          index min       node       index max      node\n");
	printf(  "                         i     j     k    min      i     j     k    max       min            max\n");
	printf(  "\n");
	dum = node_min.dns.i*ny*nz + node_min.dns.j*nz + node_min.dns.k;
	dum1 = node_max.dns.i*ny*nz + node_max.dns.j*nz + node_max.dns.k;
	printf( "density              %5d %5d %5d   %5d %5d %5d %5d   %5d %14.6e %14.6e\n",
		node_min.dns.i, node_min.dns.j, node_min.dns.k, dum,
		node_max.dns.i, node_max.dns.j, node_max.dns.k, dum1,
		min_node.dns, max_node.dns);
	dum = node_min.temp.i*ny*nz + node_min.temp.j*nz + node_min.temp.k;
	dum1 = node_max.temp.i*ny*nz + node_max.temp.j*nz + node_max.temp.k;
	printf( "temperature          %5d %5d %5d   %5d %5d %5d %5d   %5d %14.6e %14.6e\n",
		node_min.temp.i, node_min.temp.j, node_min.temp.k, dum,
		node_max.temp.i, node_max.temp.j, node_max.temp.k, dum1,
		min_node.temp, max_node.temp);
	dum = node_min.prs.i*ny*nz + node_min.prs.j*nz + node_min.prs.k;
	dum1 = node_max.prs.i*ny*nz + node_max.prs.j*nz + node_max.prs.k;
	printf( "pressure             %5d %5d %5d   %5d %5d %5d %5d   %5d %14.6e %14.6e\n",
		node_min.prs.i, node_min.prs.j, node_min.prs.k, dum,
		node_max.prs.i, node_max.prs.j, node_max.prs.k, dum1,
		min_node.prs, max_node.prs);
	dum = node_min.vx.i*ny*nz + node_min.vx.j*nz + node_min.vx.k;
	dum1 = node_max.vx.i*ny*nz + node_max.vx.j*nz + node_max.vx.k;
	printf( "velocity x           %5d %5d %5d   %5d %5d %5d %5d   %5d %14.6e %14.6e\n",
		node_min.vx.i, node_min.vx.j, node_min.vx.k, dum,
		node_max.vx.i, node_max.vx.j, node_max.vx.k, dum1,
		min_node.vx, max_node.vx);
	dum = node_min.vy.i*ny*nz + node_min.vy.j*nz + node_min.vy.k;
	dum1 = node_max.vy.i*ny*nz + node_max.vy.j*nz + node_max.vy.k;
	printf( "velocity y           %5d %5d %5d   %5d %5d %5d %5d   %5d %14.6e %14.6e\n",
		node_min.vy.i, node_min.vy.j, node_min.vy.k, dum,
		node_max.vy.i, node_max.vy.j, node_max.vy.k, dum1,
		min_node.vy, max_node.vy);
	dum = node_min.vz.i*ny*nz + node_min.vz.j*nz + node_min.vz.k;
	dum1 = node_max.vz.i*ny*nz + node_max.vz.j*nz + node_max.vz.k;
	printf( "velocity z           %5d %5d %5d   %5d %5d %5d %5d   %5d %14.6e %14.6e\n",
		node_min.vz.i, node_min.vz.j, node_min.vz.k, dum,
		node_max.vz.i, node_max.vz.j, node_max.vz.k, dum1,
		min_node.vz, max_node.vz);
	dum = node_min.enthal.i*ny*nz + node_min.enthal.j*nz + node_min.enthal.k;
	dum1 = node_max.enthal.i*ny*nz + node_max.enthal.j*nz + node_max.enthal.k;
	printf( "enthalpy             %5d %5d %5d   %5d %5d %5d %5d   %5d %14.6e %14.6e\n",
		node_min.enthal.i, node_min.enthal.j, node_min.enthal.k, dum,
		node_max.enthal.i, node_max.enthal.j, node_max.enthal.k, dum1,
		min_node.enthal, max_node.enthal);
	dum = node_min.ene.i*ny*nz + node_min.ene.j*nz + node_min.ene.k;
	dum1 = node_max.ene.i*ny*nz + node_max.ene.j*nz + node_max.ene.k;
	printf( "energy               %5d %5d %5d   %5d %5d %5d %5d   %5d %14.6e %14.6e\n",
		node_min.ene.i, node_min.ene.j, node_min.ene.k, dum,
		node_max.ene.i, node_max.ene.j, node_max.ene.k, dum1,
		min_node.ene, max_node.ene);
	dum = node_min.mach.i*ny*nz + node_min.mach.j*nz + node_min.mach.k;
	dum1 = node_max.mach.i*ny*nz + node_max.mach.j*nz + node_max.mach.k;
	printf( "mach number          %5d %5d %5d   %5d %5d %5d %5d   %5d %14.6e %14.6e\n",
		node_min.mach.i, node_min.mach.j, node_min.mach.k, dum,
		node_max.mach.i, node_max.mach.j, node_max.mach.k, dum1,
		min_node.mach, max_node.mach);
	dum = node_min.vmag.i*ny*nz + node_min.vmag.j*nz + node_min.vmag.k;
	dum1 = node_max.vmag.i*ny*nz + node_max.vmag.j*nz + node_max.vmag.k;
	printf( "velocity magnitude   %5d %5d %5d   %5d %5d %5d %5d   %5d %14.6e %14.6e\n",
		node_min.vmag.i, node_min.vmag.j, node_min.vmag.k, dum,
		node_max.vmag.i, node_max.vmag.j, node_max.vmag.k, dum1,
		min_node.vmag, max_node.vmag);
	printf( "\n");
	printf( "Orthographic viewport parameters(right, left, top, bottom, near, far)\n ");
	printf( "%14.6e %14.6e %14.6e %14.6e %14.6e %14.6e\n", ortho_right, ortho_left,
		ortho_top, ortho_bottom, near, 1000.0);
	printf( "Perspective viewport parameters( mesh width and height)\n ");
	printf( "%6d %6d\n", mesh_width, mesh_height);
	printf( "Step sizes in x, y, z\n ");
	printf( "%14.6e %14.6e %14.6e\n",step_sizex, step_sizey, step_sizez);
	printf( "Amplification size\n ");
	printf( "%14.6e\n",amplify_step0);
	printf( "Current Step, Current Time\n ");
	printf( "%7d %14.6e\n",cstep, time_current);
	printf( "nx_inc, ny_inc, nz_inc\n ");
	printf( "%5d %5d %5d\n", nx_inc, ny_inc, nz_inc);
	reget_VelocityList_flag = 0;
	if(nx_inc != nx_inc0) reget_VelocityList_flag = 1;
	if(ny_inc != ny_inc0) reget_VelocityList_flag = 1;
	if(nz_inc != nz_inc0) reget_VelocityList_flag = 1;
	nx_inc0 = nx_inc;
	ny_inc0 = ny_inc;
	nz_inc0 = nz_inc;
	printf( "line width, point size\n ");
	printf( "%14.6e %14.6e\n", line_width, point_size);
	dum = fabs(line_width0 - line_width);
	if( dum > 1.0e-5 ) reget_VelocityList_flag = 1;
	dum = fabs(point_size0 - point_size);
	if( dum > 1.0e-5 ) reget_VelocityList_flag = 1;
	line_width0 = line_width;
	point_size0 = point_size;

}

