/* This file contains the structures of the finite difference code for
   a CFD flow field. 

                     Updated 3/20/08

    SLFCFD source file
    Version:  1.1
    Copyright (C) 2005, 2006, 2007, 2008  San Le

    The source code contained in this file is released under the
    terms of the GNU Library General Public License.

*/

#include <stddef.h>
#include <stdio.h>
#include <stdlib.h>
#include <math.h>
#include "../compressible/cfdconst.h"

typedef struct {
	int i, j, k;
} IJK;

typedef struct {
	IJK dns, prs, temp, enthal, ene, vx, vy, vz, mach, vmag;
} IJK_GR_NODE;

typedef struct {
	int dns, prs, temp, enthal, ene, vx, vy, vz, mach, vmag;
} I_GR_NODE;

typedef struct {
	double x, y, z;
} XYZF_GR;

typedef struct {
	XYZF_GR face[12];
} NORM;

