/*
    This program changes the background color of the mesh display window
    to either white or grey.

    SLFFEA source file
    Version:  1.4
    Copyright (C) 2006, 2007, 2008  San Le

    The source code contained in this file is released under the
    terms of the GNU Library General Public License.
 
                        Last Update 4/15/08
 */

#if WINDOWS
#include <windows.h>
#endif

#include <stdio.h>
#include <stdlib.h>
#include <GL/gl.h>
#include <GL/glu.h>
#include <GL/glut.h>

extern int Render_flag;
extern GLfloat mat_specular[4];
extern GLfloat mat_shininess[1];
extern GLfloat light_position[4];

extern int BackGround_color;

void MeshBackGround(void)
{

   glLightfv(GL_LIGHT0, GL_POSITION, light_position);
   glEnable(GL_LIGHT0);
   glDepthFunc(GL_LEQUAL);
   glEnable(GL_DEPTH_TEST);
   glEnable (GL_BLEND);
   glBlendFunc (GL_SRC_ALPHA, GL_ONE_MINUS_SRC_ALPHA);

/* I had to make the modification below because Mesa-3.4.1 changed
   the background color from light to dark grey with:

*/
   if(BackGround_color) glClearColor(.51, .51, .51, 1.0);
   else glClearColor(1.0, 1.0, 1.0, 1.0);

   if(Render_flag)
   {

/*The lines below do shaded rendering*/

	glLoadIdentity ();  
	glMaterialfv(GL_FRONT, GL_SPECULAR, mat_specular);
	glMaterialfv(GL_FRONT, GL_SHININESS, mat_shininess);
	glEnable(GL_LIGHTING);
	glShadeModel(GL_SMOOTH);
   }
   else
   {

/* Disable the Rendering Properties */

	glDisable(GL_LIGHTING);
    }
    glutPostRedisplay();
	
}

