/*
    SLFCFD source file
    Version:  1.0
    Copyright (C) 2006  San Le 

    The source code contained in this file is released under the
    terms of the GNU Library General Public License.
 
*/

#include <stddef.h>
#include <stdio.h>
#include <stdlib.h>
#include <string.h>
#include <math.h>

int matSquare( double *C, double *A, int n)
{
/*
    This subroutine calculates the square of the matrix A 

                C(n,n) = A(n,n)*A(n,n)

	Updated 4/28/06
*/

	int i,j,k;

	memset( C, 0, n*n*sizeof(double));

	for( i = 0; i < n; ++i )
	{
	   for( j = 0; j < n; ++j )
	   {
		for( k = 0; k < n; ++k )
		{
		   *(C+n*i+j) += (*(A+n*i+k))*(*(A+n*k+j));
		}
		/*printf("%d %d %10.7f ",i,j,*(C+i*n+j));*/
	   }
	   /*printf("\n");*/
	}
	return 1;
}

int matPower( double *C, double *A, int n, int m)
{
/*
    This subroutine calculates matrix A to the power of m.

                C(n,n) = A(n,n)^m

	Updated 4/28/06
*/

	int i, i2, j, k, nsq;
	double *B;

	nsq = n*n;

	B = (double *)calloc(nsq,sizeof(double));
	memcpy( B, A, nsq*sizeof(double));

	for( i2 = 0; i2 < m; ++i2 )
	{
	    memset( C, 0, nsq*sizeof(double));
	    for( i = 0; i < n; ++i )
	    {
		for( j = 0; j < n; ++j )
		{
		    for( k = 0; k < n; ++k )
		    {
			*(C+n*i+j) += (*(A+n*i+k))*(*(B+n*k+j));
		    }
		    /*printf("%d %d %10.7f ",i,j,*(C+i*n+j));*/
		}
		/*printf("\n");*/
	    }
	    memcpy( B, C, nsq*sizeof(double));
	}
	return 1;
}

