/* This progam  uses Roe's approximate Riemann solver
   to solve Eulers Equation.  The input values have been
   set to test the shock problem of my CFD code.

               Updated 1/6/05
*/

#include <stddef.h>
#include <stdio.h>
#include <stdlib.h>
#include <math.h>

#define small		1.0e-20
#define NR_END		1
#define FREE_ARG	char*
#define nmax	 	200
#define imax	 	100
#define dx	 	.1
#define dt	 	.6e-4
#define R	 	287.0

int main()
{		
	FILE *o1;		/* input file pointer */
	FILE *o2;		/* input file pointer */
	FILE *o3;		/* input file pointer */
	int i;		/* row counter */
	int n;		/* column counter */
	float f[nmax+2][imax+2][4],a[4][4],c,ccl,ccr,gam,pos;
	float f0[4],fl[4],fr[4],pen;
	float fl2[4],fr2[4];
	float laml[4],lamr[4],rl[4][4],rr[4][4],wl[4],wr[4]; 
	float srhol,srhor,svell,svelr,srho,sh,shl,shr;
	float rhobl,rhobr,velbl,velbr,hbr,hbl,srl,srr;
	float vel0,velr,vell,rho0,rhor,rhol,h0,hr,hl,pre0,prel,prer; 
	float velrr,velll,rhorr,rholl,prell,prerr;
	float dprel,dprer,dvelr,dvell,drhor,drhol; 
	float srho0,srho1,srho2,svel0,svel1,svel2,sh0,sh1,sh2;
	float eta,c0,cl,cr,mach; 
	o1 = fopen( "p1", "w" );
	/*o2 = fopen( "p2", "w" );*/
	/*o3 = fopen( "p3", "w" );*/

	c=dt/dx;
	gam=1.4;

/* 	creating initial distribution with respect to t=0.0 and x */

	rhol=1.;
	rholl=rhol;
	prel=1.e5;
	prell=prel;
	vell=390.0;
	velll=vell;
	printf( "hhhhhh \n" );
	shl=(prel/(gam-1.)+prel)/srhol;
	for( i = 1; i < 20; ++i )
	{
	   	f[1][i][1]=rholl;
	   	f[1][i][2]=rholl*velll;
	   	f[1][i][3]=prell/(gam-1.) + 0.5*velll*velll;
	}
	rhor=.125;
	rhorr=rhor;
	prer=1.e4;
	prerr=prer;
	velr=100.0;	
	velrr=velr;	

	for( i = 20; i < imax + 1; ++i )
	{

	   	f[1][i][1]=rhorr;
	   	f[1][i][2]=rhorr*velrr;
	   	f[1][i][3]=prerr/(gam-1.) + 0.5*velrr*velrr;

	}
	
	for( n = 1; n < nmax + 1; ++n )
	{
	 	f[n][1][1]=rholl;
	   	f[n][1][2]=rholl*velll;
	   	f[n][1][3]=prell/(gam-1.) + 0.5*velll*velll;
		f[n][imax][1]=rhorr;
	   	f[n][imax][2]=rhorr*velrr;
	   	f[n][imax][3]=prerr/(gam-1.) + 0.5*velrr*velrr;
	   for( i = 2; i < imax; ++i )
	   {

		rho0=f[n][i-1][1];
		rhol=f[n][i][1];
		rhor=f[n][i+1][1];
		vel0=f[n][i-1][2]/rho0;
		vell=f[n][i][2]/rhol;
		velr=f[n][i+1][2]/rhor;
		h0=(f[n][i-1][3]-(gam-1)*rho0*vel0*vel0/(2.*gam))
			*gam/rho0;
		hl=(f[n][i][3]-(gam-1)*rhol*vell*vell/(2.*gam))
			*gam/rhol;
		hr=(f[n][i+1][3]-(gam-1)*rhor*velr*velr/(2.*gam))
			*gam/rhor;

		pre0=rho0*(h0-vel0*vel0/2.)/(1.+1./(gam-1.));
		prel=rhol*(hl-vell*vell/2.)/(1.+1./(gam-1.));
		prer=rhor*(hr-velr*velr/2.)/(1.+1./(gam-1.));
		
		f0[1]=rho0*vel0;
		f0[2]=h0*rho0*(gam-1.)/gam+(gam+1.)*rho0*vel0*vel0/(2.*gam);
		f0[3]=rho0*vel0*h0;
		fl[1]=rhol*vell;
		fl[2]=hl*rhol*(gam-1.)/gam+(gam+1.)*rhol*vell*vell/(2.*gam);
		fl[3]=rhol*vell*hl;
		fr[1]=rhor*velr;
		fr[2]=hr*rhor*(gam-1.)/gam+(gam+1.)*rhor*velr*velr/(2.*gam);
		fr[3]=rhor*velr*hr;
		
		srl=sqrt(rhol/rho0);
		srr=sqrt(rhor/rhol);

		rhobl=srl*rho0;
		rhobr=srr*rhol;
		velbl=(srl*vell+vel0)/(srl+1.);
		velbr=(srr*velr+vell)/(srr+1.);
		hbl=(srl*hl+h0)/(srl+1.);
		hbr=(srr*hr+hl)/(srr+1.);
		ccl=sqrt((gam-1.)*(hbl-velbl*velbl/2.));
		ccr=sqrt((gam-1.)*(hbr-velbr*velbr/2.));
		c0=sqrt(gam*pre0/rho0);
		cl=sqrt(gam*prel/rhol);
		cr=sqrt(gam*prer/rhor);
		
			
		/*laml[1]=velbl;
		laml[2]=velbl+ccl;
		laml[3]=velbl-ccl;
		lamr[1]=velbr;
		lamr[2]=velbr+ccr;
		lamr[3]=velbr-ccr;*/
	/*if(pen > 5) 
	{*/
		laml[1]=velbl;
		eta=((laml[1]-vel0)+fabs(laml[1]-vel0))/2.;
		if(eta < (vell-laml[1]))
		{
			eta = vell-laml[1];
		}
		if( fabs(laml[1]) < eta )
		{
			laml[1]=.5*(laml[1]*laml[1]/eta+eta);
		}	
		laml[2]=velbl+ccl;
		eta=((laml[2]-(vel0+c0))+fabs(laml[2]-(vel0+c0)))/2.;
		if(eta < (vell+cl-laml[2]))
		{
			eta = vell+cl-laml[2];
		}
		if( fabs(laml[2]) < eta )
		{
			laml[2]=.5*(laml[2]*laml[2]/eta+eta);
		}
		laml[3]=velbl-ccl;
		eta=((laml[3]-(vel0-c0))+fabs(laml[3]-(vel0-c0)))/2.;
		if(eta < ((vell-cl)-laml[3]))
		{
			eta = vell-cl-laml[3];
		}
		if( fabs(laml[3]) < eta )
		{
			laml[3]=.5*(laml[3]*laml[3]/eta+eta);
		}
		lamr[1]=velbr;
		eta=((lamr[1]-vell)+fabs(lamr[1]-vell))/2.;
		if(eta < (velr-lamr[1]))
		{
			eta = velr-lamr[1];
		}
		if( fabs(lamr[1]) < eta )
		{
			lamr[1]=.5*(lamr[1]*lamr[1]/eta+eta);
		}
		lamr[2]=velbr+ccr;
		eta=((lamr[2]-(vell+cl))+fabs(lamr[2]-(vell+cl)))/2.;
		if(eta < ((velr+cr)-lamr[2]))
		{
			eta = velr+cr-lamr[2];
		}
		if( fabs(lamr[2]) < eta )
		{
			lamr[2]=.5*(lamr[2]*lamr[2]/eta+eta);
		}
		lamr[3]=velbr-ccr;
		eta=((lamr[3]-(vell-cl))+fabs(lamr[3]-(vell-cl)))/2.;
		if(eta < (velr-cr)-lamr[3])
		{
			eta = velr-cr-lamr[3];
		}
		if( fabs(lamr[3]) < eta )
		{
			lamr[3]=.5*(lamr[3]*lamr[3]/eta+eta);
		}
	/*}*/

		rl[1][1]=1.;
		rl[1][2]=velbl;
		rl[1][3]=velbl*velbl/2.;
		rl[2][1]=rhobl/(2*ccl)*(1.);
		rl[2][2]=rhobl/(2*ccl)*(velbl+ccl);
		rl[2][3]=rhobl/(2*ccl)*(hbl+velbl*ccl);
		rl[3][1]=-rhobl/(2*ccl)*(1.);
		rl[3][2]=-rhobl/(2*ccl)*(velbl-ccl);
		rl[3][3]=-rhobl/(2*ccl)*(hbl-velbl*ccl);
		rr[1][1]=1.;
		rr[1][2]=velbr;
		rr[1][3]=velbr*velbr/2.;
		rr[2][1]=rhobr/(2*ccr)*(1.);
		rr[2][2]=rhobr/(2*ccr)*(velbr+ccr);
		rr[2][3]=rhobr/(2*ccr)*(hbr+velbr*ccr);
		rr[3][1]=-rhobr/(2*ccr)*(1.);
		rr[3][2]=-rhobr/(2*ccr)*(velbr-ccr);
		rr[3][3]=-rhobr/(2*ccr)*(hbr-velbr*ccr);
		drhol=rhol-rho0;
		drhor=rhor-rhol;
		dvell=vell-vel0;
		dvelr=velr-vell;
		dprel=prel-pre0;
		dprer=prer-prel;
		wl[1]=drhol-dprel/(ccl*ccl);
		wr[1]=drhor-dprer/(ccr*ccr);
		wl[2]=dvell+dprel/(rhol*ccl);
		wr[2]=dvelr+dprer/(rhor*ccr);
		wl[3]=dvell-dprel/(rhol*ccl);
		wr[3]=dvelr-dprer/(rhor*ccr);

		fl2[1]=.5*(fl[1]+f0[1])-
			.5*(fabs(laml[1])*wl[1]*rl[1][1])-
			.5*(fabs(laml[2])*wl[2]*rl[2][1])-
			.5*(fabs(laml[3])*wl[3]*rl[3][1]);
		fl2[2]=.5*(fl[2]+f0[2])-
			.5*(fabs(laml[1])*wl[1]*rl[1][2])-
			.5*(fabs(laml[2])*wl[2]*rl[2][2])-
			.5*(fabs(laml[3])*wl[3]*rl[3][2]);
		fl2[3]=.5*(fl[3]+f0[3])-
			.5*(fabs(laml[1])*wl[1]*rl[1][3])-
			.5*(fabs(laml[2])*wl[2]*rl[2][3])-
			.5*(fabs(laml[3])*wl[3]*rl[3][3]);

		fr2[1]=.5*(fl[1]+fr[1])-
			.5*(fabs(lamr[1])*wr[1]*rr[1][1])-
			.5*(fabs(lamr[2])*wr[2]*rr[2][1])-
			.5*(fabs(lamr[3])*wr[3]*rr[3][1]);
		fr2[2]=.5*(fl[2]+fr[2])-
			.5*(fabs(lamr[1])*wr[1]*rr[1][2])-
			.5*(fabs(lamr[2])*wr[2]*rr[2][2])-
			.5*(fabs(lamr[3])*wr[3]*rr[3][2]);
		fr2[3]=.5*(fl[3]+fr[3])-
			.5*(fabs(lamr[1])*wr[1]*rr[1][3])-
			.5*(fabs(lamr[2])*wr[2]*rr[2][3])-
			.5*(fabs(lamr[3])*wr[3]*rr[3][3]);

	   	f[n+1][i][1]=f[n][i][1]-c*(fr2[1]-fl2[1]);
	   	f[n+1][i][2]=f[n][i][2]-c*(fr2[2]-fl2[2]);
	   	f[n+1][i][3]=f[n][i][3]-c*(fr2[3]-fl2[3]);

	   }
	}

	pos=0.;
	fprintf( o1, "%5d %5d\n", imax, 4 );
	for( i = 1; i < imax + 1; ++i )
	{
		rhol=f[nmax][i][1];
		vell=f[nmax][i][2]/rhol;
		hl=(f[nmax][i][3]-(gam-1)*rhol*vell*vell/(2.*gam))
			*gam/rhol;
		prel=rhol*(hl-vell*vell/2.)/(1.+1./(gam-1.));
		cl=sqrt(gam*prel/rhol);
		mach=vell/cl;
		/*printf(  "%9.5f %9.5f %9.5f %9.5f %9.5f\n",
			pos,rhol,vell,prel,mach);*/
		/*fprintf( o1, "%9.5f %9.5f %9.5f %9.5f %9.5f\n",
			pos,rhol,vell/3.0e2,prel/1.0e5,mach);*/
		fprintf( o1, "%16.8e %16.8e %16.8e %16.8e %16.8e\n",
			pos,rhol,vell/3.0e2,prel/1.0e5,mach);
		printf( "%9.5f %9.5f %9.5f %9.5f %9.5f\n",
			pos,rhol,vell/3.0e2,prel/1.0e5,mach);
		pos=pos+dx;
	}
	        printf( "%4d ppppppp \n", i );

	return 1;
}


