/* This library function converts the last number in the abcd* file to the
   square root of that number.  This was written for me to do comparisons
   with old calculations so you should ignore it.

                     Updated 3/25/08

    SLFCFD source file
    Version:  1.1
    Copyright (C) 2005  San Le

    The source code contained in this file is released under the
    terms of the GNU Library General Public License.

*/

#include <stddef.h>
#include <stdio.h>
#include <stdlib.h>
#include <string.h>
#include "../compressible/cfdconst.h"
#include "../compressible/cfdstruct.h"

#define SMALL   1.0e-20

int sof, nx, ny, nz;
int flag_2D, flag_3D;
double dx, dy, dz;
double dt, time_current, err;
int nstep, cstep;

int main (void)
{
	int i, j, k, node_num, numnp, bc_type, check, name_length;
	char *ccheck;
	int dum, dum1, dum2,dum3,dum4,dum5;
	double fdum1, fdum2, fdum3, fdum4;
	double dns, temp, vx, vy, prs, ene, enthal, vmag;
	double gam, Re;
	char text[10], out[BUFSIZ], name[BUFSIZ], buf[BUFSIZ];
	FILE *o1, *o2, *o3;

	printf("What is the name of the file containing the \n");
	printf("finite difference CFD data? \n");
	scanf( "%s",name);

	o1 = fopen( name,"r" );
	if(o1 == NULL ) {
		printf("Can't find file %30s\n", name);
		exit(1);
	}

	o3 = fopen( "output", "w" );

	fgets( buf, BUFSIZ, o1 );
	fprintf( o3, "%s", buf);
	fscanf( o1, "%d %d %d", &numnp, &nx, &ny);
	fprintf( o3, "%4d    %4d %4d", numnp, nx, ny);

/* Every output file is named after the input file with
   a ".ofd" extension */

	name_length = strlen(name);
	if( name_length > 150) name_length = 150;

	memset(out,0,BUFSIZ*sizeof(char));

	ccheck = strncpy(out, name, name_length);
	if(!ccheck) printf( " Problems with strncpy \n");

	fgets( buf, BUFSIZ, o1 );
	fprintf( o3, "%s", buf);
	fgets( buf, BUFSIZ, o1 );
	fprintf( o3, "%s", buf);
	fgets( buf, BUFSIZ, o1 );
	fprintf( o3, "%s", buf);
	fgets( buf, BUFSIZ, o1 );
	fprintf( o3, "%s", buf);
	fgets( buf, BUFSIZ, o1 );
	fprintf( o3, "%s", buf);
	fgets( buf, BUFSIZ, o1 );
	fprintf( o3, "%s", buf);
	fgets( buf, BUFSIZ, o1 );
	fprintf( o3, "%s", buf);
	fgets( buf, BUFSIZ, o1 );
	fprintf( o3, "%s", buf);

	dum= 0;
	for ( i = 0; i < numnp; i++)
	{

		fscanf( o1, "%d %d %s", &dum1, &dum2, text);
		check = strncmp( text, "ns", 2);
		fprintf( o3, "%4d %4d    %s  ", dum1, dum2, text);
		dum5 = strlen(text);
		if( dum5 == 4 ) fprintf( o3, "  ");
		if( dum5 == 5 ) fprintf( o3, " ");
		if( !check )
		{
		    fscanf( o1, "%d", &dum3);
		    fprintf( o3, "%3d", dum3);
		}
		else fprintf( o3, "   ");
		fscanf( o1, "%lf %lf %lf %lf\n", &fdum1, &fdum2, &fdum3, &fdum4);
		fdum4 = sqrt(fdum4);

		fprintf( o3, "%12.4e %12.4e %12.4e %12.4e\n", fdum1, fdum2, fdum3, fdum4);
	}

	fprintf( o3, "%4d ",-10);

	fclose(o1);
	fclose(o3);

	return 1;
}


